
/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2003 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Id: LoadXRef.p,v 1.2 2003/12/19 07:18:55 sauge Exp sauge $" NO-UNDO. 

DEF INPUT PARAMETER cApplication    AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cFileName       AS CHARACTER NO-UNDO.

DEF VAR cRawLine        AS CHARACTER NO-UNDO.
DEF VAR cEntityName     AS CHARACTER NO-UNDO.
DEF VAR cLineNumber     AS CHARACTER NO-UNDO.
DEF VAR cRefType        AS CHARACTER NO-UNDO.
DEF VAR cRefData        AS CHARACTER NO-UNDO.

/**********************************************************/
/* Begin creating records and populating them with data   */
/* from the given XRef-file name from disk.               */
/**********************************************************/

INPUT FROM VALUE(cFileName).

REPEAT ON ENDKEY UNDO, LEAVE:

  IMPORT UNFORMATTED cRawLine.

  CREATE XRefEntry.

  ASSIGN cEntityName = ENTRY(1, cRawLine, " ")
         cFileName = ENTRY(2, cRawLine, " ").

  IF cEntityName BEGINS "./" THEN 
    ASSIGN cEntityName = SUBSTRING(cEntityName, 3).

  IF cFileName BEGINS "./" THEN 
    ASSIGN cFileName = SUBSTRING(cFileName, 3).

  ASSIGN XRefEntry.Application = cApplication
         XRefEntry.EntityName  = cEntityName
         XRefEntry.FileName    = cFileName
         XRefEntry.LineNumber  = INT(ENTRY(3, cRawLine, " "))
         XRefEntry.RefType     = ENTRY(4, cRawLine, " ")

         /*************************************************/
         /* A quick way to get the rest of the line is to */
         /* replace the beginning of the line with the    */
         /* items we already have from that line with a   */
         /* blank entry.                                  */
         /*************************************************/

         XRefEntry.RefData     = REPLACE(cRawLine,
                                          ENTRY(1, cRawLine, " ") + " "
                                        + ENTRY(2, cRawLine, " ") + " "
                                        + STRING(XRefEntry.LineNumber) + " "
                                        + XRefEntry.RefType + " ",
                                        "").
  
END. /* REPEAT: */


INPUT CLOSE.

