
/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2003 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Id: PrcRaw.p,v 1.1 2003/12/19 05:34:29 sauge Exp sauge $" NO-UNDO. 

DEF VAR cProgram    AS CHARACTER NO-UNDO.
DEF VAR cSubProgram AS CHARACTER NO-UNDO.
DEF VAR cLineNumber AS CHARACTER NO-UNDO.
DEF VAR cObjType AS CHARACTER NO-UNDO.

{Path.i}

/* Blow away the existing Processed records cuz we are doing       */
/* thing over!                                                     */

FOR EACH XRefBreakDown EXCLUSIVE-LOCK:

  DELETE XRefBreakDown.

END.

/* Here we grind through each and every line that has been read in */
/* from all xref files read into the db.                           */

FOR EACH XRefRaw USE-INDEX pukey NO-LOCK:

  RUN ipPrcLine (XRefRaw.Line).

END. /* FOR EACH XRefRaw BY LineNumber */

/* ----------------------- Internal Procedures -------------------------*/

PROCEDURE ipParseData:

  DEF INPUT PARAMETER cLine AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cProgram AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cSubProgram AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cObjType AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cObjKey  AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cObjAttr AS CHARACTER NO-UNDO.

  ASSIGN
/*
  cProgram = FileName(ENTRY(1, cLine, " "))
  cSubProgram = FileName(ENTRY(2, cLine, " "))
*/
  cProgram = ENTRY(1, cLine, " ")
  cSubProgram = ENTRY(2, cLine, " ")
  cObjType = ENTRY(4, cLine, " ")
  cObjKey = ENTRY(5, cLine, " ")
  cObjAttr = SUBSTRING(cLine, INDEX(cLine, cObjKey) + LENGTH(cObjKey) + 1).

END. /* PROCEDURE ipParseData */

PROCEDURE ipPrcLine:

  DEF INPUT PARAMETER cLine AS CHARACTER NO-UNDO.

  DEF VAR cProgram      AS CHARACTER NO-UNDO.
  DEF VAR cSubProgram   AS CHARACTER NO-UNDO.
  DEF VAR cObjType      AS CHARACTER NO-UNDO.
  DEF VAR cObjKey       AS CHARACTER NO-UNDO.
  DEF VAR cObjAttr      AS CHARACTER NO-UNDO.

  RUN ipParseData
  (INPUT cLine,
   OUTPUT cProgram,
   OUTPUT cSubProgram,
   OUTPUT cObjType,
   OUTPUT cObjKey,
   OUTPUT cObjAttr
  ).

  DISP cProgram cSubProgram cObjType cObjKey FORMAT "x(40)" cObjAttr
  WITH 1 COLUMN SIDE-LABELS CENTERED TITLE "Working On".
  PAUSE 0.

  /* Not interested in strings - plus they tend to blow up index max */
  /* field lengths.                                                  */

  IF cObjType = "STRING" THEN RETURN.

  CREATE XRefBreakDown.

  ASSIGN
  XRefBreakDown.ParentFile = cProgram
  XRefBreakDown.ChildFile = cSubProgram
  XRefBreakDown.ObjType = cObjType
  XRefBreakDown.ObjKey = cObjKey
  XRefBreakDown.ObjAttr = cObjAttr.

END. /* PROCEDURE ipPrcLine */

